import tf2_ros
from geometry_msgs.msg import TransformStamped
import rospy

class Mirror:
    """
    This object listen a particular topic and republish them over /tf topic.
    """

    def __init__(self,listen_topic=''):
        self.br = tf2_ros.TransformBroadcaster()
        self.listen_topic=listen_topic

        self.init_node()
        self.connect()

    def init_node(self):

        rospy.init_node('icm_slam_mirror_tf_publisher',anonymous=True)
        self.r=rospy.Rate(100)


    def connect(self):
        rospy.Subscriber(self.listen_topic,TransformStamped,self.mirror_process)
        rospy.spin()

    def mirror_process(self,data):
        self.br.sendTransform(data)

    def run(self):
        while not rospy.is_shutdown():
           self.r.sleep()

if __name__=='__main__':
    icm_slam=Mirror(listen_topic='/icm_slam/tf')
    icm_slam.run()

    
